/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package qsnake;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
import qsnake.Snake.Direction;

/**
 *
 * @author delia
 */
public class DetailsWindow extends javax.swing.JFrame{
    private static URL tailPath;
    private static URL dangerPath;
    private static URL fruitDirectionPath;

    public static JLabel[] snakeState = new JLabel[4]; 
    public static JLabel[] fruitPosition = new JLabel[4]; 
    public static JLabel[] snakeStateLast = new JLabel[4]; 
    public static JLabel[] fruitPositionLast = new JLabel[4]; 
    
    public DetailsWindow() {
        initComponents();
        
        setResizable(false);
        pack();
        
        setTitle("Details");
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((int)dim.width/2 + 320 + 10, 200);
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        
        tailPath = this.getClass().getResource("/images/tail.png");
        dangerPath = this.getClass().getResource("/images/danger.png");
        fruitDirectionPath = this.getClass().getResource("/images/fruit_direction.png");
        
        snakeState[0] = stateUp;
        snakeState[1] = stateRight;
        snakeState[2] = stateDown;
        snakeState[3] = stateLeft;
        
        fruitPosition[0] = fruitUp;
        fruitPosition[1] = fruitRight;
        fruitPosition[2] = fruitDown;
        fruitPosition[3] = fruitLeft;
        
        snakeStateLast[0] = stateUp1;
        snakeStateLast[1] = stateRight1;
        snakeStateLast[2] = stateDown1;
        snakeStateLast[3] = stateLeft1;
        
        fruitPositionLast[0] = fruitUp1;
        fruitPositionLast[1] = fruitRight1;
        fruitPositionLast[2] = fruitDown1;
        fruitPositionLast[3] = fruitLeft1;
        
        this.getRootPane().requestFocus();
        
        speedField.addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    try {
                        int speed = Integer.parseInt(speedField.getText());
                        
                        if(speed > 1000) {
                            speed = 1000;
                            speedField.setText("1000");
                        }
                        else if(speed < 0) {
                            throw new NumberFormatException("Negative Number");
                        }
                        
                        Board.speed = speed;
                    }
                    catch(NumberFormatException ex) {
                        speedField.setText("75");
                        Board.speed = Integer.parseInt(speedField.getText());
                    }
                }}        
        });        
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        stateUp = new javax.swing.JLabel();
        stateLeft = new javax.swing.JLabel();
        snakeIcon = new javax.swing.JLabel();
        stateRight = new javax.swing.JLabel();
        stateDown = new javax.swing.JLabel();
        fruitDown = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        fruitLeft = new javax.swing.JLabel();
        fruitRight = new javax.swing.JLabel();
        fruitUp = new javax.swing.JLabel();
        episodeLabel = new javax.swing.JLabel();
        episodeLabel1 = new javax.swing.JLabel();
        episodeLabel2 = new javax.swing.JLabel();
        currentSizeLabel = new javax.swing.JLabel();
        recordSizeLabel = new javax.swing.JLabel();
        episodeLabel3 = new javax.swing.JLabel();
        speedField = new javax.swing.JTextField();
        fruitLeft1 = new javax.swing.JLabel();
        fruitRight1 = new javax.swing.JLabel();
        fruitUp1 = new javax.swing.JLabel();
        stateUp1 = new javax.swing.JLabel();
        episodeLabel4 = new javax.swing.JLabel();
        stateLeft1 = new javax.swing.JLabel();
        snakeIcon1 = new javax.swing.JLabel();
        stateRight1 = new javax.swing.JLabel();
        stateDown1 = new javax.swing.JLabel();
        fruitDown1 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        stateUp.setBackground(new java.awt.Color(0, 0, 0));
        stateUp.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateUp.setPreferredSize(new java.awt.Dimension(32, 32));

        stateLeft.setBackground(new java.awt.Color(0, 0, 0));
        stateLeft.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateLeft.setPreferredSize(new java.awt.Dimension(32, 32));

        snakeIcon.setBackground(new java.awt.Color(0, 0, 0));
        snakeIcon.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/head.png"))); // NOI18N

        stateRight.setBackground(new java.awt.Color(0, 0, 0));
        stateRight.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateRight.setPreferredSize(new java.awt.Dimension(32, 32));

        stateDown.setBackground(new java.awt.Color(0, 0, 0));
        stateDown.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/tail.png"))); // NOI18N
        stateDown.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateDown.setPreferredSize(new java.awt.Dimension(32, 32));

        fruitDown.setBackground(new java.awt.Color(0, 0, 0));
        fruitDown.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitDown.setPreferredSize(new java.awt.Dimension(32, 32));

        jLabel11.setBackground(new java.awt.Color(0, 0, 0));
        jLabel11.setForeground(new java.awt.Color(0, 0, 0));
        jLabel11.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/head.png"))); // NOI18N

        fruitLeft.setBackground(new java.awt.Color(0, 0, 0));
        fruitLeft.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitLeft.setPreferredSize(new java.awt.Dimension(32, 32));

        fruitRight.setBackground(new java.awt.Color(0, 0, 0));
        fruitRight.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitRight.setPreferredSize(new java.awt.Dimension(32, 32));

        fruitUp.setBackground(new java.awt.Color(0, 0, 0));
        fruitUp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/fruit_direction.png"))); // NOI18N
        fruitUp.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitUp.setPreferredSize(new java.awt.Dimension(32, 32));

        episodeLabel.setFont(new java.awt.Font("Dialog", 3, 24)); // NOI18N
        episodeLabel.setText("Episode: 0");

        episodeLabel1.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        episodeLabel1.setText("Danger State");

        episodeLabel2.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        episodeLabel2.setText("Fruit Position");

        currentSizeLabel.setFont(new java.awt.Font("Dialog", 3, 24)); // NOI18N
        currentSizeLabel.setText("Current Size: 1");

        recordSizeLabel.setFont(new java.awt.Font("Dialog", 3, 24)); // NOI18N
        recordSizeLabel.setText("Size Record: 1");

        episodeLabel3.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        episodeLabel3.setText("Speed:");

        speedField.setFont(new java.awt.Font("Dialog", 0, 24)); // NOI18N
        speedField.setText("75");
        speedField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                speedFieldActionPerformed(evt);
            }
        });

        fruitLeft1.setBackground(new java.awt.Color(0, 0, 0));
        fruitLeft1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitLeft1.setPreferredSize(new java.awt.Dimension(32, 32));

        fruitRight1.setBackground(new java.awt.Color(0, 0, 0));
        fruitRight1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitRight1.setPreferredSize(new java.awt.Dimension(32, 32));

        fruitUp1.setBackground(new java.awt.Color(0, 0, 0));
        fruitUp1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/fruit_direction.png"))); // NOI18N
        fruitUp1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitUp1.setPreferredSize(new java.awt.Dimension(32, 32));

        stateUp1.setBackground(new java.awt.Color(0, 0, 0));
        stateUp1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateUp1.setPreferredSize(new java.awt.Dimension(32, 32));

        episodeLabel4.setFont(new java.awt.Font("Dialog", 1, 24)); // NOI18N
        episodeLabel4.setText("Last New State");

        stateLeft1.setBackground(new java.awt.Color(0, 0, 0));
        stateLeft1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateLeft1.setPreferredSize(new java.awt.Dimension(32, 32));

        snakeIcon1.setBackground(new java.awt.Color(0, 0, 0));
        snakeIcon1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/head.png"))); // NOI18N

        stateRight1.setBackground(new java.awt.Color(0, 0, 0));
        stateRight1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateRight1.setPreferredSize(new java.awt.Dimension(32, 32));

        stateDown1.setBackground(new java.awt.Color(0, 0, 0));
        stateDown1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/tail.png"))); // NOI18N
        stateDown1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        stateDown1.setPreferredSize(new java.awt.Dimension(32, 32));

        fruitDown1.setBackground(new java.awt.Color(0, 0, 0));
        fruitDown1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        fruitDown1.setPreferredSize(new java.awt.Dimension(32, 32));

        jLabel12.setBackground(new java.awt.Color(0, 0, 0));
        jLabel12.setForeground(new java.awt.Color(0, 0, 0));
        jLabel12.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/head.png"))); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(episodeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(recordSizeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(episodeLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(speedField, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(currentSizeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(43, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(stateLeft1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(snakeIcon1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(stateRight1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(38, 38, 38)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(stateDown1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(stateUp1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addGap(116, 116, 116)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(fruitLeft1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel12)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fruitRight1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(38, 38, 38)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(fruitDown1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(fruitUp1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addGap(29, 29, 29))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(episodeLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(12, 12, 12)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(stateLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(snakeIcon)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(stateRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addGap(38, 38, 38)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(stateDown, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(stateUp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(81, 81, 81)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(fruitLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel11)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(fruitRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addGap(38, 38, 38)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(fruitDown, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(fruitUp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                                .addGap(29, 29, 29))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(episodeLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(88, 88, 88)
                        .addComponent(episodeLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 183, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(34, 34, 34))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(episodeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(recordSizeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(episodeLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(speedField, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(currentSizeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(36, 36, 36)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(episodeLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(episodeLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(stateUp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(stateRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(stateLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(snakeIcon))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(stateDown, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(fruitUp, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(fruitRight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(fruitLeft, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel11))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(fruitDown, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(27, 27, 27)
                .addComponent(episodeLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(stateUp1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(stateRight1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(stateLeft1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(snakeIcon1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(stateDown1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(fruitUp1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(fruitRight1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(fruitLeft1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel12))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(fruitDown1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(42, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void speedFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_speedFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_speedFieldActionPerformed
    public static void clear(Direction previous) {      
        if(snakeState[0] == null)
            return;
        
        for(int i = 0; i < 4; i++) {
            if(previous.ordinal() == i) {
                snakeState[i].setIcon(new ImageIcon(tailPath));
            }
            else {
                snakeState[i].setIcon(new ImageIcon());
            }
        }
    } 
    
    public static void draw(State state, Direction previous) {
        if(snakeState[0] == null)
            return;
        
        for(int i = 0; i < 4; i++) {
            if(state.get(i) == 1 && previous.ordinal() != i) {
                snakeState[i].setIcon(new ImageIcon(dangerPath));
            }
            else if(previous.ordinal() == i) {
                snakeState[i].setIcon(new ImageIcon(tailPath));
            }
        }
        
        for(int i = 4; i < 8; i++) {
            if(state.get(i) == 1) {
                fruitPosition[i-4].setIcon(new ImageIcon(fruitDirectionPath));
            }
            else {
                fruitPosition[i-4].setIcon(new ImageIcon());
            }
        }
    }
    
    public static void drawLast(State state) {
        if(snakeState[0] == null)
            return;
        
        for(int i = 0; i < 4; i++) {
            if(state.get(i) == 1) {
                snakeStateLast[i].setIcon(new ImageIcon(dangerPath));
            }
            else if(state.get(i) == -1) {
                snakeStateLast[i].setIcon(new ImageIcon(tailPath));
            }
            else {
                snakeStateLast[i].setIcon(new ImageIcon());
            }
        }
        
        for(int i = 4; i < 8; i++) {
            if(state.get(i) == 1) {
                fruitPositionLast[i-4].setIcon(new ImageIcon(fruitDirectionPath));
            }
            else {
                fruitPositionLast[i-4].setIcon(new ImageIcon());
            }
        }
    }
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public static javax.swing.JLabel currentSizeLabel;
    public static javax.swing.JLabel episodeLabel;
    public static javax.swing.JLabel episodeLabel1;
    public static javax.swing.JLabel episodeLabel2;
    public static javax.swing.JLabel episodeLabel3;
    public static javax.swing.JLabel episodeLabel4;
    private javax.swing.JLabel fruitDown;
    private javax.swing.JLabel fruitDown1;
    private javax.swing.JLabel fruitLeft;
    private javax.swing.JLabel fruitLeft1;
    private javax.swing.JLabel fruitRight;
    private javax.swing.JLabel fruitRight1;
    private javax.swing.JLabel fruitUp;
    private javax.swing.JLabel fruitUp1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JPanel jPanel1;
    public static javax.swing.JLabel recordSizeLabel;
    private javax.swing.JLabel snakeIcon;
    private javax.swing.JLabel snakeIcon1;
    private javax.swing.JTextField speedField;
    private javax.swing.JLabel stateDown;
    private javax.swing.JLabel stateDown1;
    private javax.swing.JLabel stateLeft;
    private javax.swing.JLabel stateLeft1;
    private javax.swing.JLabel stateRight;
    private javax.swing.JLabel stateRight1;
    private javax.swing.JLabel stateUp;
    private javax.swing.JLabel stateUp1;
    // End of variables declaration//GEN-END:variables
}
